From 638146dc98d1b09b1c691eab357886b88864e328 Mon Sep 17 00:00:00 2001
From: Petr "Stone" Hracek <phracek@redhat.com>
Date: Jul 12 2017 13:05:06 +0000
Subject: [PATCH 1/2] Draft of refactoring avocado-tests.


Signed-off-by: Petr "Stone" Hracek <phracek@redhat.com>

---

diff --git a/modularity-testing-framework.spec b/modularity-testing-framework.spec
index 31f12a4..7a9e8cd 100644
--- a/modularity-testing-framework.spec
+++ b/modularity-testing-framework.spec
@@ -22,6 +22,7 @@ Requires:       docker
 Requires:       python2-dockerfile-parse
 Requires:       python2-pdc-client
 Requires:       python2-modulemd
+Requires:       python-retrying
 
 %description
 %{summary}.
diff --git a/moduleframework/avocado_testers/__init__.py b/moduleframework/avocado_testers/__init__.py
new file mode 100644
index 0000000..cbb80c5
--- /dev/null
+++ b/moduleframework/avocado_testers/__init__.py
@@ -0,0 +1,22 @@
+#!/usr/bin/python
+# -*- coding: utf-8 -*-
+#
+# This Modularity Testing Framework helps you to write tests for modules
+# Copyright (C) 2017 Red Hat, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# he Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+#
+# Authors: Petr Hracek <phracek@redhat.com>
+#
diff --git a/moduleframework/avocado_testers/container_avocado_test.py b/moduleframework/avocado_testers/container_avocado_test.py
new file mode 100644
index 0000000..a345817
--- /dev/null
+++ b/moduleframework/avocado_testers/container_avocado_test.py
@@ -0,0 +1,54 @@
+#!/usr/bin/python
+# -*- coding: utf-8 -*-
+#
+# This Modularity Testing Framework helps you to write tests for modules
+# Copyright (C) 2017 Red Hat, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# he Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+#
+# Authors: Petr Hracek <phracek@redhat.com>
+#
+
+from moduleframework.module_framework import AvocadoTest
+
+
+# INTERFACE CLASSES FOR SPECIFIC MODULE TESTS
+class ContainerAvocadoTest(AvocadoTest):
+    """
+    Class for writing tests specific just for DOCKER
+    derived from AvocadoTest class.
+
+    :avocado: disable
+    """
+
+    def setUp(self):
+        if self.moduleType != "docker":
+            self.skip("Docker specific test")
+        super(ContainerAvocadoTest, self).setUp()
+
+    def checkLabel(self, key, value):
+        """
+        check label of docker image, expect key value (could be read from config file)
+
+        :param key: str
+        :param value: str
+        :return: bool
+        """
+        if key in self.backend.containerInfo['Labels'] and (
+                    value in self.backend.containerInfo['Labels'][key]):
+            return True
+        return False
+
+
diff --git a/moduleframework/avocado_testers/nspawn_avocado_test.py b/moduleframework/avocado_testers/nspawn_avocado_test.py
new file mode 100644
index 0000000..91c395a
--- /dev/null
+++ b/moduleframework/avocado_testers/nspawn_avocado_test.py
@@ -0,0 +1,39 @@
+#!/usr/bin/python
+# -*- coding: utf-8 -*-
+#
+# This Modularity Testing Framework helps you to write tests for modules
+# Copyright (C) 2017 Red Hat, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# he Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+#
+# Authors: Petr Hracek <phracek@redhat.com>
+#
+from moduleframework.module_framework import AvocadoTest
+
+
+class NspawnAvocadoTest(AvocadoTest):
+    """
+    Class for writing tests specific just for RPM module testing inside NSPAWN env
+    derived from AvocadoTest class.
+
+    :avocado: disable
+    """
+
+    def setUp(self):
+        if self.moduleType != "nspawn":
+            self.skip("Nspawn specific test")
+        super(NspawnAvocadoTest, self).setUp()
+
+
diff --git a/moduleframework/avocado_testers/rpm_avocado_test.py b/moduleframework/avocado_testers/rpm_avocado_test.py
new file mode 100644
index 0000000..a484381
--- /dev/null
+++ b/moduleframework/avocado_testers/rpm_avocado_test.py
@@ -0,0 +1,40 @@
+#!/usr/bin/python
+# -*- coding: utf-8 -*-
+#
+# This Modularity Testing Framework helps you to write tests for modules
+# Copyright (C) 2017 Red Hat, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# he Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+#
+# Authors: Petr Hracek <phracek@redhat.com>
+#
+
+from moduleframework.module_framework import AvocadoTest
+
+
+class RpmAvocadoTest(AvocadoTest):
+    """
+    Class for writing tests specific just for LOCAL (system) RPM testing
+    derived from AvocadoTest class.
+
+    :avocado: disable
+    """
+
+    def setUp(self):
+        if self.moduleType != "rpm":
+            self.skip("Rpm specific test")
+        super(RpmAvocadoTest, self).setUp()
+
+
diff --git a/moduleframework/common.py b/moduleframework/common.py
index d9e815a..804439b 100644
--- a/moduleframework/common.py
+++ b/moduleframework/common.py
@@ -25,56 +25,15 @@
 It provides some general functions
 """
 
-import sys
 import netifaces
 import socket
 import os
-import linecache
+import urllib
 
+from avocado.utils import process
 
-class ModuleFrameworkException(Exception):
-    def __init__(self, *args, **kwargs):
-        super(ModuleFrameworkException, self).__init__(
-            'EXCEPTION MTF: ', *args, **kwargs)
-        exc_type, exc_obj, tb = sys.exc_info()
-        if tb is not None:
-            f = tb.tb_frame
-            lineno = tb.tb_lineno
-            filename = f.f_code.co_filename
-            linecache.checkcache(filename)
-            line = linecache.getline(filename, lineno, f.f_globals)
-            print "-----------\n| EXCEPTION IN: {} \n| LINE: {}, {} \n| ERROR: {}\n-----------".format(filename, lineno, line.strip(), exc_obj)
-
-
-class NspawnExc(ModuleFrameworkException):
-    def __init__(self, *args, **kwargs):
-        super(NspawnExc, self).__init__('TYPE nspawn', *args, **kwargs)
-
-
-class RpmExc(ModuleFrameworkException):
-    def __init__(self, *args, **kwargs):
-        super(RpmExc, self).__init__('TYPE rpm', *args, **kwargs)
-
-
-class ContainerExc(ModuleFrameworkException):
-    def __init__(self, *args, **kwargs):
-        super(ContainerExc, self).__init__('TYPE container', *args, **kwargs)
-
-
-class ConfigExc(ModuleFrameworkException):
-    def __init__(self, *args, **kwargs):
-        super(ConfigExc, self).__init__('TYPE config', *args, **kwargs)
-
-
-class PDCExc(ModuleFrameworkException):
-    def __init__(self, *args, **kwargs):
-        super(PDCExc, self).__init__('TYPE PDC', *args, **kwargs)
-
-
-class KojiExc(ModuleFrameworkException):
-    def __init__(self, *args, **kwargs):
-        super(KojiExc, self).__init__('TYPE Koji', *args, **kwargs)
-
+from moduleframework.exceptions import *
+from moduleframework.module_framework import get_profile
 
 defroutedev = netifaces.gateways().get('default').values(
 )[0][1] if netifaces.gateways().get('default') else "lo"
@@ -231,3 +190,164 @@ def sanitize_cmd(cmd):
         if char in cmd:
             cmd = cmd.replace(char, '\\'.join(char))
     return cmd
+
+
+class CommonFunctions(object):
+    """
+    Basic class doing configuration reading and allow do commands on host machine
+    """
+    config = None
+    modulemdConf = None
+
+    def __init__(self, *args, **kwargs):
+        self.config = None
+        self.modulemdConf = None
+        self.moduleName = None
+        self.source = None
+        self.arch = None
+        self.dependencylist = {}
+        self.moduledeps = None
+        # general use case is to have forwarded services to host (so thats why it is same)
+        self.ipaddr = trans_dict["HOSTIPADDR"]
+        trans_dict["GUESTARCH"] = self.getArch()
+
+    def getArch(self):
+        """
+        get system architecture string
+
+        :return: str
+        """
+        out = self.runHost(command='uname -m', verbose=False).stdout.strip()
+        return out
+
+    def runHost(self, command="ls /", **kwargs):
+        """
+        Run commands on host
+
+        :param command: command to exectute
+        :param kwargs: (avocado process.run) params like: shell, ignore_status, verbose
+        :return: avocado.process.run
+        """
+        try:
+            formattedcommand = command.format(**trans_dict)
+        except KeyError:
+            raise ModuleFrameworkException(
+                "Command is formatted by using trans_dict, if you want to use brackets { } in your code please use {{ "
+                "or }}, possible values in trans_dict are:",
+                trans_dict)
+        return process.run("%s" % formattedcommand, **kwargs)
+
+    def installTestDependencies(self, packages=None):
+        """
+        Which packages install to host system to satisfy environment
+
+        :param packages: List of packages, if not set, it will install rpms from config.yaml
+        :return: None
+        """
+        if not packages:
+            typo = 'testdependecies' in self.config
+            if typo:
+                warnings.warn("'testdependecies' is a typo, please fix",
+                              DeprecationWarning)
+
+            # try section without typo first
+            packages = self.config.get('testdependencies', {}).get('rpms')
+            if packages:
+                if typo:
+                    warnings.warn("preferring section without typo")
+            else:
+                # fall back to mistyped test dependency section
+                packages = self.config.get('testdependecies', {}).get('rpms')
+
+        if packages:
+            self.runHost(
+                "{HOSTPACKAGER} install " +
+                " ".join(packages),
+                ignore_status=True, verbose=is_not_silent())
+
+    def loadconfig(self):
+        """
+        Load configuration from config.yaml file (it is better to call this explicitly, than in
+        __init__ method for our purposes)
+
+        :return: None
+        """
+        try:
+            self.config = get_config()
+            self.moduleName = sanitize_text(self.config['name'])
+            self.source = self.config.get('source') if self.config.get(
+                'source') else self.config['module']['rpm'].get('source')
+        except ValueError:
+            pass
+
+    def getPackageList(self, profile=None):
+        """
+        Return list of packages what has to be installed inside module
+
+        :param profile: get list for intended profile instead of default method for searching
+        :return: list of packages (rpms)
+        """
+        out = []
+        if not profile:
+            if 'packages' in self.config:
+                packages_rpm = self.config['packages'].get('rpms') if self.config[
+                    'packages'].get('rpms') else []
+                packages_profiles = []
+                for x in self.config['packages'].get('profiles') if self.config[
+                    'packages'].get('profiles') else []:
+                    packages_profiles = packages_profiles + \
+                                        self.getModulemdYamlconfig()['data']['profiles'][x]['rpms']
+                out += packages_rpm + packages_profiles
+
+            elif self.getModulemdYamlconfig()['data'].get('profiles') and self.getModulemdYamlconfig()['data'][
+                'profiles'].get(get_profile()):
+                out += self.getModulemdYamlconfig()['data']['profiles'][get_profile()]['rpms']
+            else:
+                # fallback solution when it is not known what to install
+                out.append("bash")
+        else:
+            out += self.getModulemdYamlconfig()['data']['profiles'][profile]['rpms']
+        print_info("PCKGs to install inside module:", out)
+        return out
+
+    def getModuleDependencies(self):
+        return self.dependencylist
+
+    def getModulemdYamlconfig(self, urllink=None):
+        """
+        Return moduleMD file yaml object.
+        It can be used also for loading another yaml file via url parameter
+
+        :param urllink: load this url instead of default one defined in config, or redefined by vaiable CONFIG
+        :return: dict
+        """
+        try:
+            if urllink:
+                ymlfile = urllib.urlopen(urllink)
+                cconfig = yaml.load(ymlfile)
+                link = cconfig
+            elif not get_if_module():
+                trans_dict["GUESTPACKAGER"] = "yum -y"
+                link = {"data": {}}
+            else:
+                if self.config is None:
+                    self.loadconfig()
+                if not self.modulemdConf:
+                    modulemd = get_modulemd()
+                    if modulemd:
+                        ymlfile = urllib.urlopen(modulemd)
+                        self.modulemdConf = yaml.load(ymlfile)
+                link = self.modulemdConf
+            return link
+        except IOError as e:
+            raise ConfigExc("Cannot load file")
+
+    def getIPaddr(self):
+        """
+        Return ip addr string of guest machine
+        In many cases it should be same as host machine and port should be forwarded to host
+
+        :return: str
+        """
+        return self.ipaddr
+
diff --git a/moduleframework/exceptions.py b/moduleframework/exceptions.py
new file mode 100644
index 0000000..7b88010
--- /dev/null
+++ b/moduleframework/exceptions.py
@@ -0,0 +1,70 @@
+#!/usr/bin/python
+# -*- coding: utf-8 -*-
+#
+# This Modularity Testing Framework helps you to write tests for modules
+# Copyright (C) 2017 Red Hat, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# he Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+#
+# Authors: Jan Scotka <jscotka@redhat.com>
+#
+from __future__ import print_function
+import sys
+import linecache
+
+
+class ModuleFrameworkException(Exception):
+    def __init__(self, *args, **kwargs):
+        super(ModuleFrameworkException, self).__init__(
+            'EXCEPTION MTF: ', *args, **kwargs)
+        exc_type, exc_obj, tb = sys.exc_info()
+        if tb is not None:
+            f = tb.tb_frame
+            lineno = tb.tb_lineno
+            filename = f.f_code.co_filename
+            linecache.checkcache(filename)
+            line = linecache.getline(filename, lineno, f.f_globals)
+            print("-----------\n| EXCEPTION IN: {} \n| LINE: {}, {} \n| ERROR: {}\n-----------".format(filename, lineno, line.strip(), exc_obj))
+
+
+class NspawnExc(ModuleFrameworkException):
+    def __init__(self, *args, **kwargs):
+        super(NspawnExc, self).__init__('TYPE nspawn', *args, **kwargs)
+
+
+class RpmExc(ModuleFrameworkException):
+    def __init__(self, *args, **kwargs):
+        super(RpmExc, self).__init__('TYPE rpm', *args, **kwargs)
+
+
+class ContainerExc(ModuleFrameworkException):
+    def __init__(self, *args, **kwargs):
+        super(ContainerExc, self).__init__('TYPE container', *args, **kwargs)
+
+
+class ConfigExc(ModuleFrameworkException):
+    def __init__(self, *args, **kwargs):
+        super(ConfigExc, self).__init__('TYPE config', *args, **kwargs)
+
+
+class PDCExc(ModuleFrameworkException):
+    def __init__(self, *args, **kwargs):
+        super(PDCExc, self).__init__('TYPE PDC', *args, **kwargs)
+
+
+class KojiExc(ModuleFrameworkException):
+    def __init__(self, *args, **kwargs):
+        super(KojiExc, self).__init__('TYPE Koji', *args, **kwargs)
+
diff --git a/moduleframework/helpers/__init__.py b/moduleframework/helpers/__init__.py
new file mode 100644
index 0000000..cbb80c5
--- /dev/null
+++ b/moduleframework/helpers/__init__.py
@@ -0,0 +1,22 @@
+#!/usr/bin/python
+# -*- coding: utf-8 -*-
+#
+# This Modularity Testing Framework helps you to write tests for modules
+# Copyright (C) 2017 Red Hat, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# he Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+#
+# Authors: Petr Hracek <phracek@redhat.com>
+#
diff --git a/moduleframework/helpers/container_helper.py b/moduleframework/helpers/container_helper.py
new file mode 100644
index 0000000..c3e74fc
--- /dev/null
+++ b/moduleframework/helpers/container_helper.py
@@ -0,0 +1,277 @@
+#!/usr/bin/python
+# -*- coding: utf-8 -*-
+#
+# This Modularity Testing Framework helps you to write tests for modules
+# Copyright (C) 2017 Red Hat, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# he Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+#
+# Authors: Petr Hracek <phracek@redhat.com>
+#
+
+import re
+import json
+
+from avocado.utils import service
+
+from moduleframework.module_framework import get_url
+from moduleframework.common import *
+
+
+class ContainerHelper(CommonFunctions):
+    """
+    Basic Helper class for Docker container module type
+
+    :avocado: disable
+    """
+
+    def __init__(self):
+        """
+        set basic object variables
+        """
+        super(ContainerHelper, self).__init__()
+        self.loadconfig()
+        self.info = self.config['module']['docker']
+        self.tarbased = None
+        self.jmeno = None
+        self.docker_id = None
+        self.icontainer = get_url(
+        ) if get_url() else self.info['container']
+        if ".tar" in self.icontainer:
+            self.jmeno = "testcontainer"
+            self.tarbased = True
+        if "docker=" in self.icontainer:
+            self.jmeno = self.icontainer[7:]
+            self.tarbased = False
+        elif "docker.io" in self.info['container']:
+            # Trusted source
+            self.tarbased = False
+            self.jmeno = self.icontainer
+        else:
+            # untrusted source
+            self.tarbased = False
+            self.jmeno = self.icontainer
+
+    def getURL(self):
+        """
+        It returns actual URL link string to container, It is same as URL
+
+        :return: str
+        """
+        return self.icontainer
+
+    def getDockerInstanceName(self):
+        """
+        Return docker instance name what will be used inside docker as docker image name
+        :return: str
+        """
+        return self.jmeno
+
+    def setUp(self):
+        """
+        It is called by child class and it is same methof as Avocado/Unittest has. It prepares environment
+        for docker testing
+        * start docker if not
+        * pull docker image
+        * setup environment from config
+        * run and store identification
+
+        :return: None
+        """
+        self.installTestDependencies()
+        self.__callSetupFromConfig()
+        self.__prepare()
+        self.__prepareContainer()
+        self.__pullContainer()
+
+    def tearDown(self):
+        """
+        Cleanup environment and call also cleanup from config
+
+        :return: None
+        """
+        self.stop()
+        self.__callCleanupFromConfig()
+
+    def __prepare(self):
+        """
+        Internal method, do not use it anyhow
+
+        :return: None
+        """
+        if not os.path.isfile('/usr/bin/docker-current'):
+            self.runHost("{HOSTPACKAGER} install docker", verbose=is_not_silent())
+
+    def __prepareContainer(self):
+        """
+        Internal method, do not use it anyhow
+
+        :return: None
+        """
+        if self.tarbased is False and self.jmeno == self.icontainer and "docker.io" not in self.info[
+            'container']:
+            registry = re.search("([^/]*)", self.icontainer).groups()[0]
+            if registry not in open('/etc/sysconfig/docker', 'rw').read():
+                with open("/etc/sysconfig/docker", "a") as myfile:
+                    myfile.write(
+                        "INSECURE_REGISTRY='--insecure-registry $REGISTRY %s'" %
+                        registry)
+        service_manager = service.ServiceManager()
+        service_manager.start('docker')
+
+    def __pullContainer(self):
+        """
+        Internal method, do not use it anyhow
+
+        :return: None
+        """
+        if self.tarbased:
+            self.runHost(
+                "docker import %s %s" %
+                (self.icontainer, self.jmeno), verbose=is_not_silent())
+        elif "docker=" in self.icontainer:
+            pass
+        else:
+            self.runHost("docker pull %s" % self.jmeno, verbose=is_not_silent())
+
+        self.containerInfo = json.loads(
+            self.runHost(
+                "docker inspect %s" %
+                self.jmeno, verbose=is_not_silent()).stdout)[0]["Config"]
+
+    def start(self, args="-it -d", command="/bin/bash"):
+        """
+        start the docker container
+
+        :param args: Do not use it directly (It is defined in config.yaml)
+        :param command: Do not use it directly (It is defined in config.yaml)
+        :return: None
+        """
+        if not self.status():
+            if 'start' in self.info and self.info['start']:
+                self.docker_id = self.runHost(
+                    "%s -d %s" %
+                    (self.info['start'], self.jmeno), shell=True, ignore_bg_processes=True,
+                    verbose=is_not_silent()).stdout
+            else:
+                self.docker_id = self.runHost(
+                    "docker run %s %s %s" %
+                    (args, self.jmeno, command), shell=True, ignore_bg_processes=True, verbose=is_not_silent()).stdout
+            self.docker_id = self.docker_id.strip()
+            if self.getPackageList():
+                a = self.run(
+                    "%s install %s" %
+                    (trans_dict["HOSTPACKAGER"], " ".join(
+                        self.getPackageList())),
+                    ignore_status=True, verbose=False)
+                b = self.run(
+                    "%s install %s" %
+                    (trans_dict["GUESTPACKAGER"], " ".join(
+                        self.getPackageList())),
+                    ignore_status=True, verbose=False)
+                if a.exit_status == 0:
+                    print_info("Packages installed via {HOSTPACKAGER}", a.stdout)
+                elif b.exit_status == 0:
+                    print_info("Packages installed via {GUESTPACKAGER}", b.stdout)
+                else:
+                    print_info(
+                        "Nothing installed (nor via {HOSTPACKAGER} nor {GUESTPACKAGER}), but package list is not empty",
+                        self.getPackageList())
+        if self.status() is False:
+            raise ContainerExc(
+                "Container %s (for module %s) is not running, probably DEAD immediately after start (ID: %s)" % (
+                    self.jmeno, self.moduleName, self.docker_id))
+
+    def stop(self):
+        """
+        Stop the docker container
+
+        :return: None
+        """
+        if self.status():
+            try:
+                self.runHost("docker stop %s" % self.docker_id, verbose=is_not_silent())
+                self.runHost("docker rm %s" % self.docker_id, verbose=is_not_silent())
+            except Exception as e:
+                print_debug(e, "docker already removed")
+                pass
+
+    def status(self):
+        """
+        get status if container is running
+
+        :return: bool
+        """
+        if self.docker_id and self.docker_id[
+                              : 12] in self.runHost(
+            "docker ps", shell=True, verbose=is_not_silent()).stdout:
+            return True
+        else:
+            return False
+
+    def run(self, command="ls /", **kwargs):
+        """
+        Run command inside module, all params what allows avocado are passed inside shell,ignore_status, etc.
+
+        :param command: str
+        :param kwargs: dict
+        :return: avocado.process.run
+        """
+        self.start()
+        return self.runHost(
+            'docker exec %s bash -c "%s"' %
+            (self.docker_id, sanitize_cmd(command)),
+            **kwargs)
+
+    def copyTo(self, src, dest):
+        """
+        Copy file to module
+
+        :param src: str path to source file
+        :param dest: str path to file inside module
+        :return: None
+        """
+        self.start()
+        self.runHost("docker cp %s %s:%s" % (src, self.docker_id, dest), verbose=is_not_silent())
+
+    def copyFrom(self, src, dest):
+        """
+        Copy file from module
+
+        :param src: str path of file inside module
+        :param dest: str path of destination file
+        :return: None
+        """
+        self.start()
+        self.runHost("docker cp %s:%s %s" % (self.docker_id, src, dest), verbose=is_not_silent())
+
+    def __callSetupFromConfig(self):
+        """
+        Internal method, do not use it anyhow
+
+        :return: None
+        """
+        if self.info.get("setup"):
+            self.runHost(self.info.get("setup"), shell=True, ignore_bg_processes=True, verbose=is_not_silent())
+
+    def __callCleanupFromConfig(self):
+        """
+        Internal method, do not use it anyhow
+
+        :return: None
+        """
+        if self.info.get("cleanup"):
+            self.runHost(self.info.get("cleanup"), shell=True, ignore_bg_processes=True, verbose=is_not_silent())
+
